
# This file includes a couple helper functions that might be useful as
# you write code for this problem set.  You don't have to use this code, but
# it will probably help.


# This is a helper function for list_find_element() so that we can cleanly
# solve the problem recursively.
#
# Why do we need a separate helper function? (You can skip this explanation
# if you'd like.) 
#
# In this case, we need an extra variable n to keep track of how many
# elements we have seen in the list so far. Alternatively, we could define
# the recursive step as 1+list_find_element_helper(list[1:],value,n+1), but
# then when we return -1, the entire length of the list will be added on
# top, which is not what we want.

def list_find_element_helper(list, value, n):
    if len(list) == 0:
        return -1
    elif list[0] == value:
        return n
    else:
        return list_find_element_helper(list[1:], value, n+1)

# List_find_element looks for a specific value in a list and returns its
# index in the list.  If the element is not in the list, we return -1.
def list_find_element(list,value):
    return list_find_element_helper(list, value, 0)


# When given a comparison function and two values, pick_better
# returns one of the two elements based on the comparison function.
# For example, pick_better(lambda x,y: x<y, 7, 5) returns 5.

def pick_better(comparison_func, elt1, elt2):
    if comparison_func(elt1,elt2):
        return elt1
    else:
        return elt2

# Find best uses a comparison function and returns the one element x such
# that comparison_func(x,y) is True for all other y in the list.  For example,
# pick_better(lambda x,y: x<y, [5,9,2,3,8]) will return 2, while
# pick_better(lambda x,y: x>y, [5,9,2,3,8]) will return 9.

def find_best(comparison_func, lst):
    if len(lst) == 1:
        return lst[0]
    else:
        return pick_better(comparison_func, lst[0], find_best(comparison_func, lst[1:]))
