# ps5.py
#
# UVA CS 1120 -- Problem Set 5 -- Wahoo! Auctions
from database import *

authors = [ "mst3k" ]   # List all partner UVA IDs here, including yours

# Create the auction tables as global variables
bidders = make_new_table(["name","email"])
items = make_new_table(["item_name","description"])
bids = make_new_table(["bidder_name","item_name","amount"])

def empty_tables():
    # A helper procedure to empty our database by making new,
    # empty tables. This may be helpful for testing.
    global bidders,items,bids # Don't worry about this line
    bidders = make_new_table(["name","email"])
    items = make_new_table(["item_name","description"])
    bids = make_new_table(["bidder_name","item_name","amount"])

# Add_bidder adds a bidder entry to the bidders table
def add_bidder(name, email):
    table_insert(bidders,[name,email])

# Some code to experiment with add_bidder
#add_bidder("Tim Koogle","tk@yahoo.com")
#add_bidder("Katie Couric","katie@cbs.com")
#add_bidder("Dave Matthews","dave@dmb.com")
#table_display(bidders)

# Question 1 - write your code to answer the question below

# Question 1a
def post_item(name,description):
    # Your code here...
    return

# Question 1b
def insert_bid(bidder,item,amount):
    # Your code here...
    return

# Setup our auction tables:
def setup_tables():
    # Make the various tables we will use to run our auction/
    # Note that these tables are defined as global variables
    # in database.py, we just reset them here.
    global bidders,items,bids # Don't worry about this line
    bidders = make_new_table(["name","email"])
    items = make_new_table(["item_name","description"])
    bids = make_new_table(["bidder_name","item_name","amount"])

    # Add all of the bidders for our auction
    add_bidder("Tim Koogle","tk@yahoo.com")
    add_bidder("Tina Fey","tina@snl.com")
    add_bidder("Dave Matthews","dave@dmb.com")
    add_bidder("Katie Couric","katie@cbs.com")
    add_bidder("Bono","bono@u2.com")

    # Add all of the items being auctioned
    post_item("SEAS","School of Engine and Apple Science")
    post_item("CLAS","College of (Liberal) Arts and Sciences")
    post_item("COMM","Philip Morris School of Commerce")
    post_item("CS1120","Customer Service From Aardvarks to Zebras")
    post_item("SIS","Student Irritation System")

    # Put in some initial bids for us to work with
    insert_bid("Tim Koogle","SEAS",10000000)
    insert_bid("Dave Matthews","CLAS",2000000)
    insert_bid("Tiki Barber","COMM",79000000)
    insert_bid("Katie Couric","CLAS",37000000)
    insert_bid("Bono","SIS",1)

# Question 3 - write your code to answer the question below

def table_select(table,field,predicate):
    fieldno = table_field_number(table,field)
    if fieldno == -1:
        raise StandardError("No matching field: " + str(field))
    # Your code here...
    return

# Code to check your definition of table_select:
# --------------------------------------------------
#setup_tables()  # <--- This line must always be uncommented for these tests

#print table_select(bids,"item_name",lambda x: x=="CLAS")
# ***Expected Output: [['bidder_name', 'item_name', 'amount'], ['Dave Matthews', 'CLAS', 2000000], ['Katie Couric', 'CLAS', 37000000]]

#table_display(table_select(bids,"item_name",lambda x: x=="CLAS"))

#print table_entries(table_select(bids,"item_name",lambda x: x=="SEAS"))
# ***Expected Output: [['Tim Koogle', 'SEAS', 10000000]]

#print table_entries(table_select(bids,"item_name",lambda x: x=="The Rotunda"))
# ***Expected Output: []

#print table_entries(table_select(bids,"amount",lambda x: x>10000000))
# ***Expected Output: [['Tiki Barber', 'COMM', 79000000], ['Katie Couric', 'CLAS', 37000000]]

#print table_entries(table_select(table_select(bids,"amount",lambda x: x>10000000),"bidder_name",lambda x: x == "Katie Couric"))
# ***Expected Output: [['Katie Couric', 'CLAS', 37000000]]

# Question 5 - write your code to answer the question below
def get_bids(item):
    return table_entries(table_select(bids, "item_name", lambda x: x==item))

def get_highest_bid(item):
    # Your code here...
    return

# Test your code for Question 6:
#setup_tables()
#print get_highest_bid("SEAS")
# ***Expected Output: ['Tim Koogle', 'SEAS', 10000000]
#print get_highest_bid("Rotunda")
# ***Expected Output: []

# Question 6 - write your code to answer the question below

# place_bid should check that the bid is valid before adding it to the bids
# table:
# - The bidder must be in the bidders table
# - The item must be in the items table
# - The bid amount must be greater than the current largest bid amount

def place_bid(bidder,item,amount):
    # Your code here...
    return True

# Code to check your definition of place_bid:
#setup_tables()
#print place_bid("Tim Koogle","SEAS",20000000)
#print place_bid("Katie Couric","SEAS",18000000)
#print place_bid("Katie Couric","SEAS",22000000)
#print place_bid("Dave Matthews","The Rotunda",1000000)
#print place_bid("Wes Weimer","SEAS",10000000000)

# Question 7 - write your code to answer the question below

def end_auction():
    # Your code here...
    return

#setup_tables()
#end_auction()

# A stellar implementation of end_auction will result in the value
# 126000001 being printed when the following line is run (along with the
# rest of the results):
#print end_auction()
